#include "smtp.h"

extern smtpi jtin;

void smtp_paid_mtq(void *arg)
   {

   smtp_tu par_o= (smtp_tu) arg;
   char *lcPaid,*lcFile,*lcJID;
   xmlnode loFile,loJID;
   int liRet=0;

   if ((lcPaid=xmlnode_get_tag_data(jtin->config,"core/paid"))==NULL)
      {
      pool_free(par_o->p);
      return;
      }

//   log_notice("smtp","PAID - module: %s", lcPaid);

   for (loFile = xmlnode_get_tag(jtin->roster_files,"file"); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
       {
       if (loFile->type!=NTYPE_TAG)
          continue;

       lcFile=xmlnode_get_tag_data(jtin->roster,spools(par_o->p,"file?type=",xmlnode_get_attrib(loFile,"type"),par_o->p))  ;
//       log_notice("smtp","PAID - file: %s", lcFile);

       // walk all jid in file
       for (loJID = xmlnode_get_tag(loFile,"item"); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
           {
           if (loJID->type!=NTYPE_TAG)
               continue;

           lcJID=xmlnode_get_attrib(loJID,"jid");
           if (lcJID!=NULL)
              {
              liRet=system(spools(par_o->p,lcPaid," '",lcJID,"'",par_o->p));
              xmlnode_put_attrib(loJID,"paid",smtp_itoa(par_o->p,liRet));
              }
           else
              log_alert("smtp","ROSTER - JID not define for item: %s.",xmlnode2str(loJID));

           }

       if (lcFile!=NULL && xmlnode2file(lcFile,loFile)!=1)
          {
          log_alert("smtp","ROSTER - Cannot save roster-letter file %s.",lcFile);
          smtp_SendInfoToAdmin(spools(par_o->p,"ROSTER - Cannot save roster-letter file ",lcFile,".",par_o->p ),SMTP_SITA_P);
          }
       }

//   log_notice("smtp","PAID - END");
   pool_free(par_o->p);
//   log_notice("smtp","PAID - END-END");
   }




// create new thread for getting paid flag
result smtp_paid_daemon(void *arg)
   {
   pool p=pool_new();
   smtp_PoolsReg(30, p);

   smtp_tu par_o;

   par_o=pmalloco(p, sizeof(_smtp_tu));
   par_o->p=p;

   par_o->q=mtq_new(p);
   mtq_send(par_o->q, p, smtp_paid_mtq, (void *)par_o);
   return r_DONE;
   }
